#include "i2c.h"

volatile static int	i2cRegime=0;		//0-
						//1-   
						//2-   

volatile static unsigned i2cAdr;
volatile static char i2cByte;
volatile static char i2cMS;

void	i2cInit(void)
{
I2C_PINSEL_SCL;			// 
I2C_PINSEL_SDA;
I2C_D_H=PCLK/2/I2C_F;		// 
I2C_D_L=PCLK/2/I2C_F;

I2C_CON_C=0xFF;

VICIntSelect&=~(1<<VIC_I2C);	//   I2C,  IRQ 
I2C_VICVectAddr=(unsigned long)i2cIRQ;
I2C_VICVectCntl=0x20|VIC_I2C;	//   I2C
VICIntEnable=1<<VIC_I2C;	//   I2C

}

void	i2cIRQ1(void)
{
static int nByte;  
static int	iByte;

if(!i2cRegime)
	{
	I2C_CON_C=0xFF;
	return;
	}
switch(I2C_STAT)
	{
	case	0x08:		// ""
	I2C_CON_C=0x20;			// ""
	iByte=i2cMS;
	I2C_DAT=iByte;
	break;
	
	case	0x10:		// " "
	I2C_CON_C=0x20;			// ""
	iByte=i2cMS|1;
	I2C_DAT=iByte;
	break;
	
	case	0x18:		//  ,  
	iByte=i2cAdr>>8;	//   
	I2C_DAT=iByte;
	nByte=0;
	break;
	
	case	0x28:		//  ,  
	switch(nByte)
		{
		case	0:	//   ,  
		iByte=i2cAdr;
		I2C_DAT=iByte;
		nByte=1;
		break;
		
		case	1:	//   
		switch(i2cRegime)
			{	
			case	1:  //
			iByte=i2cByte;
			I2C_DAT=iByte;
			nByte=2;
			break;
		
			case	2:	//   
			I2C_CON_S=0x20;
			break;
			}
		break;
		
		case	2:	//   . 
		I2C_CON_S=0x10;
		nByte=0;
//		i2cRegime=0;
		break;
		}
//	break;
	
	case	0x40:			//  +   
	I2C_CON_C=0x04;			// 
	break;
	
	case	0x58:			// 
	i2cRegime=0; 
	I2C_CON_S=0x10;
	i2cByte=I2C_DAT;
	break;
	}
I2C_CON_C=0x8;

}


void	i2cIRQ(void)
{
static int nByte;  
static int	iByte;
int	qq;

//switch(i2cRegime)
//	{    
//	case	1:		// 
qq=I2C_STAT;
switch(qq)
		{
		case	0x08:		// 
		I2C_CON_C=0x20;			// ""
		iByte=i2cMS;
		I2C_DAT=iByte;
		nByte=1;
		break;
	
		case	0x20:			//  , 
		I2C_DAT=iByte;
		break;
	
		case	0x18:		// 
		case	0x28:		// 
		switch(nByte)
			{
			case	1:
			iByte=i2cAdr>>8;
			break;
			
			case	2:
			iByte=i2cAdr;
			break;
			
			case	3:
			iByte=i2cByte;
			break;
			
			case	4:
			I2C_CON_S=0x10;			// ""
			i2cRegime=0;
			return;
			}
		I2C_DAT=iByte;
		nByte++;
	  	break;
		}
/*	break;

	case	2:		// 
	switch(I2C_STAT)
		{
		case	0x08:		// 
		I2C_CON_C=0x20;			// ""
		iByte=i2cMS;
		I2C_DAT=iByte;
		nByte=1;
		break;
	
		case	0x20:			//  , 
		I2C_DAT=iByte;
		break;
	
		case	0x18:		// 
		case	0x28:		// 
		switch(nByte)
			{
			case	1:
			iByte=i2cAdr>>8;
		I2C_DAT=iByte;
			break;
			
			case	2:
			iByte=i2cAdr;
		I2C_DAT=iByte;
			break;
			
			case	3:
			I2C_CON_S=0x20;			// " "
			break;
			
			case	4:
//			I2C_CON_S=0x10;			// ""
//			i2cRegime=0;
//			return;
			}
		nByte++;
	  	break;
		}
	break;
	}*/
I2C_CON_C=0x8;

}


int	i2cWrite(unsigned char ms,unsigned Adr,unsigned char b)
{
int	i=0xfff;

while(i--)
	{
	if(!i2cRegime)
	    break;
	}
if(i<0)
	return -1;
i2cAdr=Adr;
i2cByte=b;
i2cMS=ms;
I2C_CON_C=0xFF;
I2C_CON_S=0x40;			// I2C
I2C_CON_S=0x20;			// ""
i2cRegime=1;
while(i--)
	{
	  if(!i2cRegime)
	    break;
	}
return i>=0?0:-1; 
}


int	i2cRead(unsigned char ms,unsigned Adr,unsigned char *b)
{
int	i=0xfff;

while(i--)
	{
	if(!i2cRegime)
	    break;
	}
if(i<0)
	return -1;
i2cAdr=Adr;
i2cMS=ms;
I2C_CON_C=0xFF;
I2C_CON_S=0x40;			// I2C
I2C_CON_S=0x20;			// ""
i2cRegime=2;
while(i--)
	{
	  if(!i2cRegime)
	    break;
	}
if(i>=0)
	{
	*b=i2cByte;
	return	0;
	}

return -1; 
}


